// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::{ffi, Endpoint, SparqlConnection};
use glib::{prelude::*, translate::*};

glib::wrapper! {
    #[doc(alias = "TrackerEndpointDBus")]
    pub struct EndpointDBus(Object<ffi::TrackerEndpointDBus>) @extends Endpoint, @implements gio::Initable;

    match fn {
        type_ => || ffi::tracker_endpoint_dbus_get_type(),
    }
}

impl EndpointDBus {
    #[doc(alias = "tracker_endpoint_dbus_new")]
    pub fn new(
        sparql_connection: &SparqlConnection,
        dbus_connection: &gio::DBusConnection,
        object_path: Option<&str>,
        cancellable: Option<&impl IsA<gio::Cancellable>>,
    ) -> Result<EndpointDBus, glib::Error> {
        skip_assert_initialized!();
        unsafe {
            let mut error = std::ptr::null_mut();
            let ret = ffi::tracker_endpoint_dbus_new(
                sparql_connection.to_glib_none().0,
                dbus_connection.to_glib_none().0,
                object_path.to_glib_none().0,
                cancellable.map(|p| p.as_ref()).to_glib_none().0,
                &mut error,
            );
            if error.is_null() {
                Ok(from_glib_full(ret))
            } else {
                Err(from_glib_full(error))
            }
        }
    }

    #[doc(alias = "dbus-connection")]
    pub fn dbus_connection(&self) -> Option<gio::DBusConnection> {
        ObjectExt::property(self, "dbus-connection")
    }

    #[doc(alias = "object-path")]
    pub fn object_path(&self) -> Option<glib::GString> {
        ObjectExt::property(self, "object-path")
    }
}
